﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	
	import flash.geom.ColorTransform;

	public class Fibonacci extends Sprite
	{
		private var max:Number;
		private var fibonacci:Number;
		private var rapport:Number;
		private var rad:Number;
		private var growth:Number;
		
		private var cur:Number;
		private var rot:Number;
		
		public var ax:Number = 300;
		public var ay:Number = 300;
		
		public var balls:Array;
		public var obj:Object;
		
		private var modulo:Number=100;
		private var positifNegatif:Number=1;
		
		public function Fibonacci()
		{
			
			balls=new Array;
			
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
			setup();
		}
		private function setup():void
		{
			
			max			= 1000;
			fibonacci	= 1/1.618033989;
			rapport 	= 360-40*fibonacci - 4.9;
			growth		= 1.003;
			rot			= 0;
		}
		
		private function addedHandler(e:Event):void
		{
			addEventListener(Event.ENTER_FRAME, enterhandler);
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, mouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, mouseUp);
			
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			graphics.clear();
			setup();
			//removeEventListener(Event.ENTER_FRAME,enterhandler);
		}
		
		private function mouseDown(e:MouseEvent):void
		{
			removeEventListener(Event.ENTER_FRAME, enterhandler);
		}
		
		private function mouseUp(e:MouseEvent):void
		{
			graphics.clear();
			addEventListener(Event.ENTER_FRAME, enterhandler);
		}
		
		private function enterhandler(e:Event):void
		{
			this.graphics.clear();
			//trace(balls.length);
			
			rad = modulo;
			
			if (modulo % 125 == 40) {positifNegatif*= -1;}
			modulo += positifNegatif;
				
				rot += rapport;
				rot-= new int(rot/360)*360;
				//rad*=growth;
				
				ax = mouseX+Math.cos(rot * Math.PI/180) *rad;
				ay = mouseY+Math.sin(rot * Math.PI/180) *rad;
				
				obj = {"x1":ax, "y1":ay};
				balls.push(obj);
																	
				for (var i:Number=0; i<balls.length; i++){
										
					if (i>3) {
											
						graphics.lineStyle(.2,0x000000,1);
						graphics.beginFill(0xffffff,1);
						
						graphics.moveTo(balls[i].x1, balls[i].y1);
						graphics.lineTo(balls[i-2].x1, balls[i-2].y1);
						//graphics.lineTo(balls[i-Math.round(Math.random()*2+1)].x1, balls[i-Math.round(Math.random()*2+1)].y1);
						graphics.lineTo(balls[i-3].x1, balls[i-3].y1);
						graphics.lineTo(balls[i].x1, balls[i].y1);
						graphics.endFill();
					}
				}
				
						graphics.lineStyle(1,0x000000,1);
						graphics.beginFill(0x000000,1);
						graphics.drawCircle(mouseX,mouseY,10);
						graphics.endFill();
						graphics.moveTo(mouseX,mouseY);
						graphics.lineTo(ax,ay);
		}
		
		
	}
}